---
- name: Configure swap space
  block:
    - name: Check for swap file
      ansible.builtin.stat:
        path: /swapfile
      register: swapfile

    - name: Create swap file
      ansible.builtin.command:
        cmd: dd if=/dev/zero of=/swapfile bs=1M count=2048
      when: not swapfile.stat.exists

    - name: Set permissions on swap file
      ansible.builtin.file:
        path: /swapfile
        mode: '0600'
      when: not swapfile.stat.exists

    - name: Set up swap space
      ansible.builtin.command:
        cmd: mkswap /swapfile
      when: not swapfile.stat.exists

    - name: Enable swap file
      ansible.builtin.command:
        cmd: swapon /swapfile
      when: not swapfile.stat.exists

    - name: Add swap entry to fstab
      ansible.builtin.lineinfile:
        path: /etc/fstab
        line: '/swapfile none swap sw 0 0'
        create: yes
      when: not swapfile.stat.exists
  become: yes
